using Raylib_cs;

namespace Smoll.Ex2
{
    class RaylibAssetManagerModule : IEngineModule {
        string path;

        Dictionary<string, Image> images;
        Dictionary<string, Sound> sounds;

        public RaylibAssetManagerModule(string path  = "./assets") {
            this.path = path;
            images = new Dictionary<string, Image>();
            sounds = new Dictionary<string, Sound>();
        }

        public Image GetImage(string name) {
            Image image;
            if(! images.TryGetValue(name, out image)) {    
                image = Raylib.LoadImage(path+"/"+name);
                images.Add(name, image);
            }
            return image;
        } 

        public Sound GetSound(string name) {
            Sound sound;
            if(! sounds.TryGetValue(name, out sound)) {    
                sound = Raylib.LoadSound(path+"/"+name);
                sounds.Add(name, sound);
            }
            return sound;
        } 
    }
}